/**************************
 * Includes
 *
 **************************/

#include <windows.h>
#include <gl/gl.h>
#include "SerialClass.h"
#include <stdio.h>
#include <math.h>
#include <vector>
using namespace std;

/**************************
 * Function Declarations
 *
 **************************/

LRESULT CALLBACK WndProc (HWND hWnd, UINT message,
WPARAM wParam, LPARAM lParam);
void EnableOpenGL (HWND hWnd, HDC *hDC, HGLRC *hRC);
void DisableOpenGL (HWND hWnd, HDC hDC, HGLRC hRC);

int CharToInt( char val )
{
	switch ( val )
	{
		case '0':
			return 0;
		case '1':
			return 1;
		case '2':
			return 2;
		case '3':
			return 3;
		case '4':
			return 4;
		case '5':
			return 5;
		case '6':
			return 6;
		case '7':
			return 7;
		case '8':
			return 8;
		case '9':
			return 9;
	}
	return 0;
}


int field = 0;
BYTE value[5];
bool procesing = false;
bool datachange = false;
Serial * serial;
bool automatic = false;
vector<BYTE*> AutomaticPositions;
int automaticpos = 0;


void DrawBox( float x, float y, float sx, float sy, float r, float g, float b )
{
    glBegin(GL_QUADS);
    glColor3f(r,g,b);
    y = 1-y;
    glVertex2f(x*2.0f-1.0f,y*2.0f-1.0f);
    glVertex2f((x+sx)*2.0f-1.0f,y*2.0f-1.0f);
    glVertex2f((x+sx)*2.0f-1.0f,(y-sy)*2.0f-1.0f);
    glVertex2f(x*2.0f-1.0f,(y-sy)*2.0f-1.0f);
    glEnd();
}

/**************************
 * WinMain
 *
 **************************/

int WINAPI WinMain (HINSTANCE hInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpCmdLine,
                    int iCmdShow)
{
    WNDCLASS wc;
    HWND hWnd;
    HDC hDC;
    HGLRC hRC;        
    MSG msg;
    BOOL bQuit = FALSE;
    float theta = 0.0f;

    /* register window class */
    wc.style = CS_OWNDC;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor (NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "GLSample";
    RegisterClass (&wc);

    /* create main window */
    hWnd = CreateWindow (
      "GLSample", "Robotyczne ramie", 
      WS_CAPTION | WS_POPUPWINDOW | WS_VISIBLE,
      0, 0, 400, 400,
      NULL, NULL, hInstance, NULL);

    /* enable OpenGL for the window */
    EnableOpenGL (hWnd, &hDC, &hRC);
    	
    
    
    // 5 - 70 - 155
	// 0 - 70 - 140
    serial = new Serial("COM8");
    DWORD time = GetTickCount();
    char str[100];
    
    for( int i = 0; i < 5; i++ )
    	value[i] = 90;
    
    /* program main loop */
    while (!bQuit)
    {
        /* check for messages */
        if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
        {
            /* handle or dispatch messages */
            if (msg.message == WM_QUIT)
            {
                bQuit = TRUE;
            }
            else
            {
                TranslateMessage (&msg);
                DispatchMessage (&msg);
            }
        }
        else
        {
            /* OpenGL animation code goes here */

            glClearColor (0.0f, 0.0f, 0.0f, 0.0f);
            glClear (GL_COLOR_BUFFER_BIT);
			
            glPushMatrix ();
            
            //draw position list
            for( int d = 0; d < AutomaticPositions.size(); d++ )
            {
            	int i = d;
            	float c = 0;
				while( i >= 28 )
				{
            		i -= 28;
            		c += 1;
            	}
            	if( automaticpos == d )
	            	DrawBox((((float)i)/28.0f)+0.005f,c*(1.0f/28.0f)+0.005f,1.0f/28.0f-0.01f,1.0f/28.0f-0.01f,0.75f,0,0);
	            else
	            	DrawBox((((float)i)/28.0f)+0.005f,c*(1.0f/28.0f)+0.005f,1.0f/28.0f-0.01f,1.0f/28.0f-0.01f,0,0.75f,0);
	            DrawBox((((float)i)/28.0f)+0.01f,0.01f+c*(1.0f/28.0f),1.0f/28.0f-0.02f,1.0f/28.0f-0.02f,0,0.45f,0);
            }
			
            //draw edit menu
            for( int i = 1; i < 8; i++ )
            {
            	if( i < 6 )
            	{
	            	if( field == i - 1 )
	            		DrawBox(0.005f,(((float)i)/7.0f)+0.005f,1.0f/2.0f-0.01f,1.0f/7.0f-0.01f,0.75f,0,0);
	            	else
	            		DrawBox(0.005f,(((float)i)/7.0f)+0.005f,1.0f/2.0f-0.01f,1.0f/7.0f-0.01f,0,0.75f,0);
	            	DrawBox(0.01f,(((float)i)/7.0f)+0.01f,1.0f/2.0f-0.02f,1.0f/7.0f-0.02f,0,0.45f,0);
	            	
			        DrawBox(0.5f,(((float)i)/7.0f)+0.05f,1.0f/2.0f,1.0f/7.0f-0.1f,0,0.75f,0);
			        DrawBox(0.51f,(((float)i)/7.0f)+0.06f,1.0f/2.0f-0.02f,1.0f/7.0f-0.12f,0,0.45f,0);
			        DrawBox(0.51f,(((float)i)/7.0f)+0.06f,(1.0f/2.0f-0.02f)*(((float)value[i-1])/180.0f),1.0f/7.0f-0.12f,0.45f,0,0);
		    	}
		    	else
		    	{
		    		if( i == 6 )
		    		{
			    		DrawBox(0.005f,(((float)i)/7.0f)+0.005f,1.0f/4.0f-0.01f,1.0f/7.0f-0.01f,0,0,0.95f);
			    		if( !automatic )
		            		DrawBox(0.01f,(((float)i)/7.0f)+0.01f,1.0f/4.0f-0.02f,1.0f/7.0f-0.02f,0,0,0.55f);
		            	else
		            		DrawBox(0.01f,(((float)i)/7.0f)+0.01f,1.0f/4.0f-0.02f,1.0f/7.0f-0.02f,0.45f,0,0);
			    		DrawBox(0.255f,(((float)i)/7.0f)+0.005f,1.0f/2.0f-0.01f,1.0f/7.0f-0.01f,0.75f,0.75f,0);
			    		if( !procesing )
		            		DrawBox(0.26f,(((float)i)/7.0f)+0.01f,1.0f/2.0f-0.02f,1.0f/7.0f-0.02f,0.45f,0.45f,0);
		            	else
		            		DrawBox(0.26f,(((float)i)/7.0f)+0.01f,1.0f/2.0f-0.02f,1.0f/7.0f-0.02f,0.45f,0,0);
	            	}
	            	if( i == 7 )
	            	{
	            		i--;
	            		if( field != i - 1 )
            				DrawBox(0.755f,(((float)i)/7.0f)+0.005f,1.0f/4.0f-0.01f,1.0f/7.0f-0.01f,0,0.75f,0);
            			else
            				DrawBox(0.755f,(((float)i)/7.0f)+0.005f,1.0f/4.0f-0.01f,1.0f/7.0f-0.01f,0.75f,0,0);
			    		
		            	DrawBox(0.76f,(((float)i)/7.0f)+0.01f,1.0f/4.0f-0.02f,1.0f/7.0f-0.02f,0,0.45f,0);
		            	i++;
	            	}
		    	}
       		}
       		
            
            glPopMatrix ();

            SwapBuffers (hDC);
            if( !automatic )
            {
	            if( !procesing && datachange )
	            {
	            	datachange = false;
	            	serial->WriteData(value,5);
	            	procesing = true;
	            }
	            
	            if( procesing )
	            {
	            	if( serial->countData() != 0 )
				    {
					    int len = serial->countData();
					    serial->ReadData(str,serial->countData());
					    procesing = false;
					}
	            }
        	}
        	else
        	{
        		if( AutomaticPositions.size() > 0 )
        		{
        			if( !procesing )
        			{
	        			for( int i = 0; i < 5; i++ )
		       			{
		       				value[i] = AutomaticPositions.at(automaticpos)[i];
		       			}
		       			datachange = true;
	       			}
	       			if( !procesing && datachange )
		            {
		            	datachange = false;
		            	serial->WriteData(value,5);
		            	procesing = true;
		            }
	       			if( procesing )
		            {
		            	if( serial->countData() != 0 )
					    {
						    int len = serial->countData();
						    serial->ReadData(str,serial->countData());
						    procesing = false;
						    automaticpos++;
			       			if( automaticpos == AutomaticPositions.size() - 1 )
			       			{
			       				automatic = false;
			       			}
						}
		            }
        		}
        		else
        		{
        			automatic = false;
        		}
        	}
            theta += 1.0f;
            Sleep (1);
        }
    }
	delete serial;
    /* shutdown OpenGL */
    DisableOpenGL (hWnd, hDC, hRC);

    /* destroy the window explicitly */
    DestroyWindow (hWnd);

    return msg.wParam;
}

/********************
 * Window Procedure
 *
 ********************/

LRESULT CALLBACK WndProc (HWND hWnd, UINT message,
                          WPARAM wParam, LPARAM lParam)
{
	BYTE * data;
	int i;
    switch (message)
    {
    case WM_CREATE:
        return 0;
    case WM_CLOSE:
        PostQuitMessage (0);
        return 0;

    case WM_DESTROY:
        return 0;

    case WM_KEYDOWN:
        switch (wParam)
        {
        case VK_DOWN:
        	field++;
        	if( field > 5 )
        		field = 0;
        	return 0;
        case VK_UP:
        	field--;
        	if( field < 0 )
        		field = 5;
        	return 0;
        
        case VK_ADD:
        	if( AutomaticPositions.size() < 28*4 )
        	{
	        	data = new BYTE[5];
	        	memcpy(data,value,5);
	        	AutomaticPositions.push_back(data);
				automaticpos = AutomaticPositions.size()-1;
			}
        	return 0;
        case VK_SUBTRACT:
        	if( automaticpos < AutomaticPositions.size() )
        	{
	        	AutomaticPositions.erase(AutomaticPositions.begin()+automaticpos);
	        	if( AutomaticPositions.size() - 1 < automaticpos )
	        		automaticpos = AutomaticPositions.size() - 1;
        	}
        	return 0;
        case VK_LEFT:
        	if( field  < 5 )
        	{
	        	if( value[field] > 0 )
	        		value[field]--;
	        	if( AutomaticPositions.size() > 0 )
        			AutomaticPositions.at(automaticpos)[field] = value[field];
	        	datachange = true;
       		}
       		else
       		{
       			automaticpos--;
       			if( automaticpos < 0 )
       				automaticpos = AutomaticPositions.size() - 1;
       			for( i =0; i < 5; i++ )
       			{
       				value[i] = AutomaticPositions.at(automaticpos)[i];
       			}
       			datachange = true;
       		}
        	return 0;
        case VK_RIGHT:
        	if( field < 5 )
        	{
	        	value[field]++;
        		if( value[field] > 180 )
        			value[field] = 180;
        		if( AutomaticPositions.size() > 0 )
        			AutomaticPositions.at(automaticpos)[field] = value[field];
        		datachange = true;
       		}
       		else
       		{
       			automaticpos++;
       			if( AutomaticPositions.size() - 1 < automaticpos )
	        		automaticpos = 0;
	        	for( i =0; i < 5; i++ )
       			{
       				value[i] = AutomaticPositions.at(automaticpos)[i];
       			}
       			datachange = true;
       		}
        	return 0;
        case VK_RETURN:
        	automaticpos = 0;
        	automatic = !automatic;
        	return 0;
        case VK_ESCAPE:
            PostQuitMessage(0);
            return 0;
        }
        return 0;

    default:
        return DefWindowProc (hWnd, message, wParam, lParam);
    }
}


/*******************
 * Enable OpenGL
 *
 *******************/

void EnableOpenGL (HWND hWnd, HDC *hDC, HGLRC *hRC)
{
    PIXELFORMATDESCRIPTOR pfd;
    int iFormat;

    /* get the device context (DC) */
    *hDC = GetDC (hWnd);

    /* set the pixel format for the DC */
    ZeroMemory (&pfd, sizeof (pfd));
    pfd.nSize = sizeof (pfd);
    pfd.nVersion = 1;
    pfd.dwFlags = PFD_DRAW_TO_WINDOW | 
      PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
    pfd.iPixelType = PFD_TYPE_RGBA;
    pfd.cColorBits = 32;
    pfd.cDepthBits = 32;
    pfd.iLayerType = PFD_MAIN_PLANE;
    iFormat = ChoosePixelFormat (*hDC, &pfd);
    SetPixelFormat (*hDC, iFormat, &pfd);

    /* create and enable the render context (RC) */
    *hRC = wglCreateContext( *hDC );
    wglMakeCurrent( *hDC, *hRC );

}


/******************
 * Disable OpenGL
 *
 ******************/

void DisableOpenGL (HWND hWnd, HDC hDC, HGLRC hRC)
{
    wglMakeCurrent (NULL, NULL);
    wglDeleteContext (hRC);
    ReleaseDC (hWnd, hDC);
}
